package domowe.r4.pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class PoliczWszystkieSlowa_v2 {

    public static void main(String[] args) {
        Map<String, Integer> slownik = new TreeMap<>();
        
        try(Scanner scanner = new Scanner(new File("pliki/pan_tadeusz.txt"))) {
            scanner.useDelimiter("[^\\p{L}\\d]+");
            while(scanner.hasNext()) {
                String slowo = scanner.next().toLowerCase();
                slownik.put(slowo, slownik.getOrDefault(slowo, 0) + 1);
            }
        } catch(FileNotFoundException e) {
            e.printStackTrace();
        }
        
        // Sortujemy wyniki wg liczby wystąpień:
        // Najpierw tworzę listę wpisów, a nastepnie tę listę sortuję wg wartości
        List<Map.Entry<String, Integer>> lista = new ArrayList<>(slownik.entrySet());
        lista.sort(Map.Entry.comparingByValue());
        
        for(Map.Entry<String, Integer> entry : lista) {
            System.out.println(entry.getKey() + " → " + entry.getValue());
        }
    }

}
